=== debian/changelog ===
rdma-core (39.0-1) unstable; urgency=medium

  * New upstream release.
  * Remove i40iw provider conffile (Closes: #1000562)
  * Update overrides for lintian 2.114
  * Override obsolete-command-in-modprobe.d-file lintian error
  * Override spare-manual-page lintian complaint

 -- Benjamin Drung <benjamin.drung@ionos.com>  Thu, 27 Jan 2022 19:57:04 +0100

rdma-core (38.0-1) unstable; urgency=medium

  * New upstream release.
  * debian: Add __verbs_log to private libibverbs symbols

 -- Benjamin Drung <benjamin.drung@ionos.com>  Fri, 19 Nov 2021 17:57:18 +0100

rdma-core (36.0-2) unstable; urgency=medium

  * Revert installing systemd services in /usr/lib/systemd/system.
    See #994388 for more details. (Closes: #997727)

 -- Benjamin Drung <benjamin.drung@ionos.com>  Tue, 09 Nov 2021 11:13:56 +0100

rdma-core (36.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0
  * Install systemd services in /usr/lib/systemd/system
  * Mark libraries as Multi-Arch: same

 -- Benjamin Drung <benjamin.drung@ionos.com>  Mon, 13 Sep 2021 14:09:01 +0200
