=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: rdma-core
-Maintainer: Benjamin Drung <benjamin.drung@ionos.com>
+Maintainer: Benjamin Drung <bdrung@ubuntu.com>
 Section: net
 Priority: optional
 Build-Depends: cmake (>= 2.8.11),
@@ -18,8 +18,8 @@
                python3-docutils,
                valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x]
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
-Vcs-Git: https://github.com/linux-rdma/rdma-core.git -b debian/master
+Standards-Version: 4.6.1
+Vcs-Git: https://github.com/linux-rdma/rdma-core.git -b debian/unstable
 Vcs-Browser: https://github.com/linux-rdma/rdma-core
 Homepage: https://github.com/linux-rdma/rdma-core
 
@@ -293,3 +293,4 @@
          ${misc:Depends},
          ${perl:Depends},
          ${shlibs:Depends}
+Description: InfiniBand diagnostic programs
