## rdma-core 43.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -77,7 +77,7 @@
 set(PACKAGE_NAME "RDMA")
 
 # See Documentation/versioning.md
-set(PACKAGE_VERSION "39.0")
+set(PACKAGE_VERSION "43.0")
 # When this is changed the values in these files need changing too:
 #   debian/control
 #   debian/libibverbs1.symbols
@@ -89,32 +89,34 @@
 
 # Override the CMAKE_INSTALL_ dirs to be under the build/ directory
 if (IN_PLACE)
-  set(CMAKE_INSTALL_SYSCONFDIR "${CMAKE_BINARY_DIR}/etc")
-  set(CMAKE_INSTALL_BINDIR "${CMAKE_BINARY_DIR}/bin")
-  set(CMAKE_INSTALL_SBINDIR "${CMAKE_BINARY_DIR}/bin")
-  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}")
+  set(CMAKE_INSTALL_SYSCONFDIR "${PROJECT_BINARY_DIR}/etc")
+  set(CMAKE_INSTALL_BINDIR "${PROJECT_BINARY_DIR}/bin")
+  set(CMAKE_INSTALL_SBINDIR "${PROJECT_BINARY_DIR}/bin")
+  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}")
   set(CMAKE_INSTALL_LIBDIR "lib")
   set(CMAKE_INSTALL_INCLUDEDIR "include")
 endif()
 
 include(GNUInstallDirs)
 # C include root
-set(BUILD_INCLUDE ${CMAKE_BINARY_DIR}/include)
+set(BUILD_INCLUDE ${PROJECT_BINARY_DIR}/include)
 # Executables
-set(BUILD_BIN ${CMAKE_BINARY_DIR}/bin)
+set(BUILD_BIN ${PROJECT_BINARY_DIR}/bin)
 # Libraries
-set(BUILD_LIB ${CMAKE_BINARY_DIR}/lib)
+set(BUILD_LIB ${PROJECT_BINARY_DIR}/lib)
 # Static library pre-processing
-set(BUILD_STATIC_LIB ${CMAKE_BINARY_DIR}/lib/statics)
+set(BUILD_STATIC_LIB ${PROJECT_BINARY_DIR}/lib/statics)
 # Used for IN_PLACE configuration
-set(BUILD_ETC ${CMAKE_BINARY_DIR}/etc)
-set(BUILD_PYTHON ${CMAKE_BINARY_DIR}/python)
+set(BUILD_ETC ${PROJECT_BINARY_DIR}/etc)
+set(BUILD_PYTHON ${PROJECT_BINARY_DIR}/python)
 
 set(IBDIAG_CONFIG_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/infiniband-diags")
 set(IBDIAG_NODENAME_MAP_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/rdma/ib-node-name-map")
 
 set(CMAKE_INSTALL_INITDDIR "${CMAKE_INSTALL_SYSCONFDIR}/init.d"
   CACHE PATH "Location for init.d files")
+set(CMAKE_INSTALL_MODPROBEDIR "${CMAKE_INSTALL_SYSCONFDIR}/modprobe.d/"
+  CACHE PATH "Location for modprobe.d files")
 set(CMAKE_INSTALL_SYSTEMD_SERVICEDIR "${CMAKE_INSTALL_PREFIX}/lib/systemd/system"
   CACHE PATH "Location for systemd service files")
 set(CMAKE_INSTALL_SYSTEMD_BINDIR "/lib/systemd"
@@ -169,7 +171,7 @@
 
 #-------------------------
 # Load CMake components
-set(BUILDLIB "${CMAKE_SOURCE_DIR}/buildlib")
+set(BUILDLIB "${PROJECT_SOURCE_DIR}/buildlib")
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${BUILDLIB}")
 
 include(CMakeParseArguments)
@@ -217,6 +219,11 @@
   set(CYTHON_EXECUTABLE "")
 endif()
 
+find_program(SYSTEMCTL_BIN systemctl HINTS "/usr/bin" "/bin")
+if (NOT SYSTEMCTL_BIN)
+  set (SYSTEMCTL_BIN "/bin/systemctl")
+endif()
+
 RDMA_CheckSparse()
 
 # Require GNU99 mode
@@ -257,6 +264,16 @@
   RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNO_MISSING_FIELD_INITIALIZERS "-Wno-missing-field-initializers")
 endif()
 
+# clang doesn't support variable size GCC extension
+RDMA_Check_C_Compiles(HAVE_C_VARIABLE_SIZE "
+ struct c { int a; int b[]; };
+ struct foo { struct c c; int b; };
+ int main(int argc,const char *argv[]) { return 0; }"
+)
+if (NOT HAVE_C_VARIABLE_SIZE)
+	RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNO_VARIABLE_SIZE "-Wno-gnu-variable-sized-type-not-at-end")
+endif()
+
 # Check that the compiler supports -fno-strict-aliasing.
 # The use of this flag in the source is discouraged
 set(NO_STRICT_ALIASING_FLAGS "")
@@ -290,25 +307,3 @@
  int main(int argc,const char *argv[]) { _sym(); }"
 )
 
-# The code does not do the racy fcntl if the various CLOEXEC's are not
-# supported so it really doesn't work right if this isn't available. Thus hard
-# require it.
-CHECK_C_SOURCE_COMPILES("
- #include <sys/types.h>
- #include <sys/stat.h>
- #include <sys/socket.h>
- #include <fcntl.h>
- int main(int argc,const char *argv[]) {
-    open(\".\",O_RDONLY | O_CLOEXEC);
-    socket(AF_INET, SOCK_STREAM | SOCK_CLOEXEC, 0);
-    return 0;
- }" HAS_CLOEXEC)
-
-if (NOT HAS_CLOEXEC)
-# At least uclibc wrongly hides this POSIX constant behind _GNU_SOURCE
-CHECK_C_SOURCE_COMPILES("
- #define _GNU_SOURCE
- #include <sys/types.h>
- #include <sys/stat.h>
- #include <sys/socket.h>
- #include <fcntl.h>
