=== kernel-headers/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
   rdma/bnxt_re-abi.h
   rdma/cxgb4-abi.h
   rdma/efa-abi.h
+  rdma/erdma-abi.h
   rdma/hns-abi.h
   rdma/ib_user_ioctl_cmds.h
   rdma/ib_user_ioctl_verbs.h
@@ -48,9 +49,9 @@
     set(HDRS ${HDRS} ${OHDR})
     add_custom_command(
       OUTPUT "${OHDR}"
-      COMMAND "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/buildlib/make_abi_structs.py" "${IHDR}" "${OHDR}"
+      COMMAND "${PYTHON_EXECUTABLE}" "${PROJECT_SOURCE_DIR}/buildlib/make_abi_structs.py" "${IHDR}" "${OHDR}"
       MAIN_DEPENDENCY "${IHDR}"
-      DEPENDS "${CMAKE_SOURCE_DIR}/buildlib/make_abi_structs.py"
+      DEPENDS "${PROJECT_SOURCE_DIR}/buildlib/make_abi_structs.py"
       WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
       COMMENT "Creating ABI wrapper ${OHDR}"
       )
@@ -65,6 +66,7 @@
   rdma/bnxt_re-abi.h
   rdma/cxgb4-abi.h
   rdma/efa-abi.h
+  rdma/erdma-abi.h
   rdma/hns-abi.h
   rdma/ib_user_verbs.h
   rdma/irdma-abi.h
