=== debian/control ===
--- 
+++ 
@@ -90,6 +90,7 @@
   - bnxt_re: Broadcom NetXtreme-E RoCE HCAs
   - cxgb4: Chelsio T4 iWARP HCAs
   - efa: Amazon Elastic Fabric Adapter
+  - erdma: Alibaba Elastic RDMA (iWarp) Adapter
   - hfi1verbs: Intel Omni-Path HFI
   - hns: HiSilicon Hip06 SoC
   - ipathverbs: QLogic InfiniPath HCAs
@@ -293,4 +294,3 @@
          ${misc:Depends},
          ${perl:Depends},
          ${shlibs:Depends}
-Description: InfiniBand diagnostic programs
